;;; elmo-search-spotlight.el --- Spotlight support for elmo-search.

;; Copyright (C) 2006  Nao Kawanishi <river2470@gmail.com>

;; Author: Nao Kawanishi <river2470@gmail.com>
;; Keywords: mail, net news

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;;; Code:

(require 'elmo-search)

(defcustom elmo-search-spotlight-default-target "~/Mail"
  "*Default target for spotlight.")

(defun elmo-search-spotlight-target (engine pattern)
  (let ((dirname (elmo-search-engine-param-internal engine)))
    (if (string-match "^$" dirname)
	(setq dirname elmo-search-spotlight-default-target))
    (setq target (expand-file-name dirname))
    target))

(elmo-search-register-engine
 'spotlight 'local-file
 :prog "mdfind"
 :args '("-onlyin" elmo-search-spotlight-target
	 pattern)
 :charset 'utf-8)

(provide 'elmo-search-spotlight)

;;; elmo-search-spotlight.el ends here
